Index: code/branches/questsystem5/src/orxonox/objects/gametypes/Gametype.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/gametypes/Gametype.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/gametypes/Gametype.cc	(revision 2908)
@@ -36,5 +36,5 @@
 #include "core/ConfigValueIncludes.h"
 #include "core/Template.h"
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "overlays/OverlayGroup.h"
 #include "objects/infos/PlayerInfo.h"
@@ -44,4 +44,6 @@
 #include "objects/worldentities/Camera.h"
 
+#include "network/Host.h"
+
 namespace orxonox
 {
@@ -64,6 +66,8 @@
         this->setConfigValues();
 
+        this->addBots(this->numberOfBots_);
+
         // load the corresponding score board
-        if (GameMode::showsGraphics() && this->scoreboardTemplate_ != "")
+        if (Core::showsGraphics() && this->scoreboardTemplate_ != "")
         {
             this->scoreboard_ = new OverlayGroup(this);
@@ -101,6 +105,5 @@
     void Gametype::start()
     {
-        this->addBots(this->numberOfBots_);
-
+        COUT(0) << "game started" << std::endl;
         this->gtinfo_.bStarted_ = true;
 
@@ -110,4 +113,5 @@
     void Gametype::end()
     {
+        COUT(0) << "game ended" << std::endl;
         this->gtinfo_.bEnded_ = true;
     }
@@ -116,7 +120,11 @@
     {
         this->players_[player].state_ = PlayerState::Joined;
-    }
-
-    bool Gametype::playerLeft(PlayerInfo* player)
+
+        std::string message = player->getName() + " entered the game";
+        COUT(0) << message << std::endl;
+        Host::Broadcast(message);
+    }
+
+    void Gametype::playerLeft(PlayerInfo* player)
     {
         std::map<PlayerInfo*, Player>::iterator it = this->players_.find(player);
@@ -124,7 +132,9 @@
         {
             this->players_.erase(it);
-            return true;
-        }
-        return false;
+
+            std::string message = player->getName() + " left the game";
+            COUT(0) << message << std::endl;
+            Host::Broadcast(message);
+        }
     }
 
@@ -137,5 +147,5 @@
     }
 
-    bool Gametype::playerChangedName(PlayerInfo* player)
+    void Gametype::playerChangedName(PlayerInfo* player)
     {
         if (this->players_.find(player) != this->players_.end())
@@ -143,8 +153,9 @@
             if (player->getName() != player->getOldName())
             {
-                return true;
-            }
-        }
-        return false;
+                std::string message = player->getOldName() + " changed name to " + player->getName();
+                COUT(0) << message << std::endl;
+                Host::Broadcast(message);
+            }
+        }
     }
 
@@ -157,37 +168,23 @@
     }
 
-    void Gametype::playerPreSpawn(PlayerInfo* player)
-    {
-    }
-
-    void Gametype::playerPostSpawn(PlayerInfo* player)
-    {
-    }
-
-    void Gametype::playerStartsControllingPawn(PlayerInfo* player, Pawn* pawn)
-    {
-    }
-
-    void Gametype::playerStopsControllingPawn(PlayerInfo* player, Pawn* pawn)
-    {
-    }
-
-    bool Gametype::allowPawnHit(Pawn* victim, Pawn* originator)
-    {
-        return true;
-    }
-
-    bool Gametype::allowPawnDamage(Pawn* victim, Pawn* originator)
-    {
-        return true;
-    }
-
-    bool Gametype::allowPawnDeath(Pawn* victim, Pawn* originator)
-    {
-        return true;
-    }
-
     void Gametype::pawnKilled(Pawn* victim, Pawn* killer)
     {
+        if (victim && victim->getPlayer())
+        {
+            std::string message;
+            if (killer)
+            {
+                if (killer->getPlayer())
+                    message = victim->getPlayer()->getName() + " was killed by " + killer->getPlayer()->getName();
+                else
+                    message = victim->getPlayer()->getName() + " was killed";
+            }
+            else
+                message = victim->getPlayer()->getName() + " died";
+
+            COUT(0) << message << std::endl;
+            Host::Broadcast(message);
+        }
+
         if (victim && victim->getPlayer())
         {
@@ -201,7 +198,11 @@
                 if (killer)
                 {
-                    std::map<PlayerInfo*, Player>::iterator it = this->players_.find(killer->getPlayer());
-                    if (it != this->players_.end())
-                        it->second.frags_++;
+                    std::map<PlayerInfo*, Player>::iterator itKiller = this->players_.find(killer->getPlayer());
+                    if (itKiller != this->players_.end())
+                    {
+                        this->playerScored(itKiller->second);
+                    }
+                    else
+                        COUT(2) << "Warning: Killing Pawn was not in the playerlist" << std::endl;
                 }
 
@@ -224,18 +225,7 @@
     }
 
-    void Gametype::playerScored(PlayerInfo* player)
-    {
-        std::map<PlayerInfo*, Player>::iterator it = this->players_.find(player);
-        if (it != this->players_.end())
-            it->second.frags_++;
-    }
-
-    int Gametype::getScore(PlayerInfo* player) const
-    {
-        std::map<PlayerInfo*, Player>::const_iterator it = this->players_.find(player);
-        if (it != this->players_.end())
-            return it->second.frags_;
-        else
-            return 0;
+    void Gametype::playerScored(Player& player)
+    {
+        player.frags_++;
     }
 
@@ -346,8 +336,6 @@
         if (spawnpoint)
         {
-            this->playerPreSpawn(player);
             player->startControl(spawnpoint->spawn());
             this->players_[player].state_ = PlayerState::Alive;
-            this->playerPostSpawn(player);
         }
         else
@@ -361,5 +349,5 @@
     {
         for (unsigned int i = 0; i < amount; ++i)
-            this->botclass_.fabricate(this);
+            new Bot(this);
     }
 
Index: code/branches/questsystem5/src/orxonox/objects/gametypes/Gametype.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/gametypes/Gametype.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/gametypes/Gametype.h	(revision 2908)
@@ -84,28 +84,17 @@
             virtual void end();
             virtual void playerEntered(PlayerInfo* player);
-            virtual bool playerLeft(PlayerInfo* player);
+            virtual void playerLeft(PlayerInfo* player);
             virtual void playerSwitched(PlayerInfo* player, Gametype* newgametype);
             virtual void playerSwitchedBack(PlayerInfo* player, Gametype* oldgametype);
-            virtual bool playerChangedName(PlayerInfo* player);
+            virtual void playerChangedName(PlayerInfo* player);
 
-            virtual void playerScored(PlayerInfo* player);
-
-            virtual bool allowPawnHit(Pawn* victim, Pawn* originator = 0);
-            virtual bool allowPawnDamage(Pawn* victim, Pawn* originator = 0);
-            virtual bool allowPawnDeath(Pawn* victim, Pawn* originator = 0);
+            virtual void playerScored(Player& player);
 
             virtual void pawnKilled(Pawn* victim, Pawn* killer = 0);
             virtual void pawnPreSpawn(Pawn* pawn);
             virtual void pawnPostSpawn(Pawn* pawn);
-            virtual void playerPreSpawn(PlayerInfo* player);
-            virtual void playerPostSpawn(PlayerInfo* player);
-
-            virtual void playerStartsControllingPawn(PlayerInfo* player, Pawn* pawn);
-            virtual void playerStopsControllingPawn(PlayerInfo* player, Pawn* pawn);
 
             inline const std::map<PlayerInfo*, Player>& getPlayers() const
                 { return this->players_; }
-
-            int getScore(PlayerInfo* player) const;
 
             inline void registerSpawnPoint(SpawnPoint* spawnpoint)
@@ -117,9 +106,4 @@
                 { return this->gtinfo_.startCountdown_; }
 
-            inline void setHUDTemplate(const std::string& name)
-                { this->gtinfo_.hudtemplate_ = name; }
-            inline const std::string& getHUDTemplate() const
-                { return this->gtinfo_.hudtemplate_; }
-
             void addBots(unsigned int amount);
             void killBots(unsigned int amount = 0);
@@ -128,12 +112,15 @@
                 { return this->players_.size(); }
 
-        protected:
+        private:
             virtual SpawnPoint* getBestSpawnPoint(PlayerInfo* player) const;
 
-            virtual void assignDefaultPawnsIfNeeded();
-            virtual void checkStart();
-            virtual void spawnPlayer(PlayerInfo* player);
-            virtual void spawnPlayersIfRequested();
-            virtual void spawnDeadPlayersIfRequested();
+            void addPlayer(PlayerInfo* player);
+            void removePlayer(PlayerInfo* player);
+
+            void assignDefaultPawnsIfNeeded();
+            void checkStart();
+            void spawnPlayer(PlayerInfo* player);
+            void spawnPlayersIfRequested();
+            void spawnDeadPlayersIfRequested();
 
             GametypeInfo gtinfo_;
@@ -144,5 +131,4 @@
             float initialStartCountdown_;
             unsigned int numberOfBots_;
-            SubclassIdentifier<Bot> botclass_;
 
             std::map<PlayerInfo*, Player> players_;
Index: code/branches/questsystem5/src/orxonox/objects/infos/Bot.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/Bot.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/Bot.cc	(revision 2908)
@@ -30,5 +30,5 @@
 #include "Bot.h"
 
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
@@ -46,5 +46,5 @@
 
         this->bHumanPlayer_ = false;
-        this->bLocalPlayer_ = GameMode::isMaster();
+        this->bLocalPlayer_ = Core::isMaster();
         this->bSetUnreadyAfterSpawn_ = false;
         this->setReadyToSpawn(true);
Index: code/branches/questsystem5/src/orxonox/objects/infos/CMakeLists.txt
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/CMakeLists.txt	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/CMakeLists.txt	(revision 2908)
@@ -1,5 +1,4 @@
 ADD_SOURCE_FILES(ORXONOX_SRC_FILES
   Bot.cc
-  PongBot.cc
   Info.cc
   PlayerInfo.cc
Index: code/branches/questsystem5/src/orxonox/objects/infos/GametypeInfo.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/GametypeInfo.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/GametypeInfo.cc	(revision 2908)
@@ -58,5 +58,4 @@
         registerVariable(this->startCountdown_,         variableDirection::toclient);
         registerVariable(this->bStartCountdownRunning_, variableDirection::toclient);
-        registerVariable(this->hudtemplate_,            variableDirection::toclient);
     }
 }
Index: code/branches/questsystem5/src/orxonox/objects/infos/GametypeInfo.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/GametypeInfo.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/GametypeInfo.h	(revision 2908)
@@ -56,7 +56,4 @@
                 { return this->startCountdown_; }
 
-            inline const std::string& getHUDTemplate() const
-                { return this->hudtemplate_; }
-
         private:
             bool bStarted_;
@@ -64,5 +61,4 @@
             bool bStartCountdownRunning_;
             float startCountdown_;
-            std::string hudtemplate_;
     };
 }
Index: code/branches/questsystem5/src/orxonox/objects/infos/HumanPlayer.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/HumanPlayer.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/HumanPlayer.cc	(revision 2908)
@@ -30,5 +30,5 @@
 #include "HumanPlayer.h"
 
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "core/ConfigValueIncludes.h"
@@ -47,12 +47,9 @@
         RegisterObject(HumanPlayer);
 
-        this->server_initialized_ = GameMode::isMaster();
+        this->server_initialized_ = Core::isMaster();
         this->client_initialized_ = false;
 
         this->bHumanPlayer_ = true;
         this->defaultController_ = Class(HumanController);
-
-        this->humanHud_ = 0;
-        this->gametypeHud_ = 0;
 
         this->setConfigValues();
@@ -62,12 +59,4 @@
     HumanPlayer::~HumanPlayer()
     {
-        if (this->BaseObject::isInitialized())
-        {
-            if (this->humanHud_)
-                delete this->humanHud_;
-
-            if (this->gametypeHud_)
-                delete this->gametypeHud_;
-        }
     }
 
@@ -93,5 +82,5 @@
             this->synchronize_nick_ = this->nick_;
 
-            if (GameMode::isMaster())
+            if (Core::isMaster())
                 this->setName(this->nick_);
         }
@@ -100,5 +89,5 @@
     void HumanPlayer::configvaluecallback_changedHUDTemplate()
     {
-        this->setHumanHUDTemplate(this->hudtemplate_);
+        this->changedController();
     }
 
@@ -116,5 +105,5 @@
             this->client_initialized_ = true;
 
-            if (!GameMode::isMaster())
+            if (!Core::isMaster())
                 this->setObjectMode(objectDirection::bidirectional);
             else
@@ -122,5 +111,4 @@
 
             this->createController();
-            this->updateHumanHUD();
         }
     }
@@ -158,50 +146,12 @@
     }
 
-    void HumanPlayer::changedGametype()
+    void HumanPlayer::changedController()
     {
-        PlayerInfo::changedGametype();
+        if (this->getController())
+        {
+            this->getController()->setHUDTemplate(this->hudtemplate_);
 
-        if (this->isInitialized() && this->isLocalPlayer())
-            if (this->getGametype()->getHUDTemplate() != "")
-                this->setGametypeHUDTemplate(this->getGametype()->getHUDTemplate());
-    }
-
-    void HumanPlayer::changedControllableEntity()
-    {
-        PlayerInfo::changedControllableEntity();
-
-        if (this->humanHud_)
-            this->humanHud_->setOwner(this->getControllableEntity());
-    }
-
-    void HumanPlayer::updateHumanHUD()
-    {
-        if (this->humanHud_)
-        {
-            delete this->humanHud_;
-            this->humanHud_ = 0;
-        }
-
-        if (this->isLocalPlayer() && this->humanHudTemplate_ != "")
-        {
-            this->humanHud_ = new OverlayGroup(this);
-            this->humanHud_->addTemplate(this->humanHudTemplate_);
-            this->humanHud_->setOwner(this->getControllableEntity());
-        }
-    }
-
-    void HumanPlayer::updateGametypeHUD()
-    {
-        if (this->gametypeHud_)
-        {
-            delete this->gametypeHud_;
-            this->gametypeHud_ = 0;
-        }
-
-        if (this->isLocalPlayer() && this->gametypeHudTemplate_ != "")
-        {
-            this->gametypeHud_ = new OverlayGroup(this);
-            this->gametypeHud_->addTemplate(this->gametypeHudTemplate_);
-            this->gametypeHud_->setOwner(this->getGametype());
+            if (this->getController() && this->getController()->getHUD())
+                this->getController()->getHUD()->setOwner(this->getControllableEntity());
         }
     }
Index: code/branches/questsystem5/src/orxonox/objects/infos/HumanPlayer.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/HumanPlayer.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/HumanPlayer.h	(revision 2908)
@@ -51,32 +51,5 @@
             void setClientID(unsigned int clientID);
 
-            virtual void changedGametype();
-            virtual void changedControllableEntity();
-
-            inline void setHumanHUDTemplate(const std::string& name)
-            {
-                if (name != this->humanHudTemplate_)
-                {
-                    this->humanHudTemplate_ = name;
-                    this->updateHumanHUD();
-                }
-            }
-            inline const std::string& getHumanHUDTemplate() const
-                { return this->humanHudTemplate_; }
-            inline OverlayGroup* getHumanHUD() const
-                { return this->humanHud_; }
-
-            inline void setGametypeHUDTemplate(const std::string& name)
-            {
-                if (name != this->gametypeHudTemplate_)
-                {
-                    this->gametypeHudTemplate_ = name;
-                    this->updateGametypeHUD();
-                }
-            }
-            inline const std::string& getGametypeHUDTemplate() const
-                { return this->gametypeHudTemplate_; }
-            inline OverlayGroup* getGametypeHUD() const
-                { return this->gametypeHud_; }
+            virtual void changedController();
 
         protected:
@@ -88,7 +61,4 @@
             void networkcallback_client_initialized();
 
-            void updateHumanHUD();
-            void updateGametypeHUD();
-
             std::string nick_;
             std::string synchronize_nick_;
@@ -96,9 +66,4 @@
             bool server_initialized_;
             bool client_initialized_;
-
-            std::string humanHudTemplate_;
-            OverlayGroup* humanHud_;
-            std::string gametypeHudTemplate_;
-            OverlayGroup* gametypeHud_;
     };
 }
Index: code/branches/questsystem5/src/orxonox/objects/infos/PlayerInfo.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/PlayerInfo.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/PlayerInfo.cc	(revision 2908)
@@ -110,9 +110,4 @@
     void PlayerInfo::createController()
     {
-        if (this->controller_)
-        {
-            delete this->controller_;
-            this->controller_ = 0;
-        }
         this->controller_ = this->defaultController_.fabricate(this);
         assert(this->controller_);
@@ -146,6 +141,4 @@
         if (this->controller_)
             this->controller_->setControllableEntity(entity);
-
-        this->changedControllableEntity();
     }
 
@@ -162,6 +155,4 @@
             if (callback)
                 entity->removePlayer();
-
-            this->changedControllableEntity();
         }
     }
Index: code/branches/questsystem5/src/orxonox/objects/infos/PlayerInfo.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/infos/PlayerInfo.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/infos/PlayerInfo.h	(revision 2908)
@@ -49,7 +49,4 @@
             virtual void changedGametype();
 
-            virtual void changedController() {}
-            virtual void changedControllableEntity() {}
-
             inline bool isHumanPlayer() const
                 { return this->bHumanPlayer_; }
@@ -76,4 +73,5 @@
             inline Controller* getController() const
                 { return this->controller_; }
+            virtual void changedController() {}
 
         protected:
Index: code/branches/questsystem5/src/orxonox/objects/items/MultiStateEngine.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/items/MultiStateEngine.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/items/MultiStateEngine.cc	(revision 2908)
@@ -30,5 +30,5 @@
 #include "MultiStateEngine.h"
 
-#include "core/GameMode.h"
+#include "core/Core.h"
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
@@ -123,5 +123,5 @@
             }
 
-            if (GameMode::isMaster())
+            if (Core::isMaster())
             {
                 for (std::list<WorldEntity*>::const_iterator it = this->activeEffects_.begin(); it != this->activeEffects_.end(); ++it)
Index: code/branches/questsystem5/src/orxonox/objects/pickup/PickupSpawner.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/pickup/PickupSpawner.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/pickup/PickupSpawner.cc	(revision 2908)
@@ -89,5 +89,5 @@
 		ExecutorMember<BaseObject>* executor = createExecutor(createFunctor(&BaseObject::setActive));
 		executor->setDefaultValues(true);
-		RespawnTimer_.setTimer(this->respawntimer_, false, this, executor);
+		RespawnTimer_.setTimer(this->respawntimer_, false, (BaseObject*)this, executor);
 		COUT(0) << "TIMER SET" << std::endl;
 	}
Index: code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/quest/AddQuest.cc	(revision 2908)
@@ -42,5 +42,5 @@
 #include "orxonox/objects/infos/PlayerInfo.h"
 #include "QuestManager.h"
-#include "QuestDescription.h"
+#include "QuestDescription.h";
 #include "Quest.h"
 
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/Munition.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/Munition.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/Munition.cc	(revision 2908)
@@ -105,4 +105,5 @@
     void Munition::fillBullets()
     {
+//COUT(0) << "Munition::fillBullets maxBullets_=" << this->maxBullets_ << std::endl;
         this->bullets_ = this->maxBullets_;
     }
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/Weapon.cc
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/Weapon.cc	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/Weapon.cc	(revision 2908)
@@ -42,16 +42,13 @@
     {
         RegisterObject(Weapon);
-
         this->bulletReadyToShoot_ = true;
         this->magazineReadyToShoot_ = true;
         this->parentWeaponSystem_ = 0;
         this->attachedToWeaponSlot_ = 0;
+        this->munition_ = 0;
         this->bulletLoadingTime_ = 0;
         this->magazineLoadingTime_ = 0;
         this->bReloading_ = false;
-        this->bulletAmount_= 0;
-        this->magazineAmount_ = 0;
-        this->munition_ = 0;
-        this->unlimitedMunition_ = false;
+
         this->setObjectMode(0x0);
     }
@@ -68,7 +65,4 @@
         XMLPortParam(Weapon, "bulletLoadingTime", setBulletLoadingTime, getBulletLoadingTime, xmlelement, mode);
         XMLPortParam(Weapon, "magazineLoadingTime", setMagazineLoadingTime, getMagazineLoadingTime, xmlelement, mode);
-        XMLPortParam(Weapon, "bullets", setBulletAmount, getBulletAmount, xmlelement, mode);
-        XMLPortParam(Weapon, "magazines", setMagazineAmount, getMagazineAmount, xmlelement, mode);
-        XMLPortParam(Weapon, "unlimitedMunition", setUnlimitedMunition, getUnlimitedMunition, xmlelement, mode);
     }
 
@@ -79,46 +73,35 @@
     }
 
-    void Weapon::setMunition()
-    {
-        this->munition_->setMaxBullets(this->bulletAmount_);
-        this->munition_->setMaxMagazines(this->magazineAmount_);
-    }
 
     void Weapon::fire()
     {
+//COUT(0) << "LaserGun::fire, this=" << this << std::endl;
         if ( this->bulletReadyToShoot_ && this->magazineReadyToShoot_ && !this->bReloading_)
         {
+//COUT(0) << "LaserGun::fire - ready to shoot" << std::endl;
+//COUT(0) << "LaserGun::fire - bullets" << this->munition_->bullets() << std::endl;
             this->bulletReadyToShoot_ = false;
-            if ( this->unlimitedMunition_== true )
+            if ( this->munition_->bullets() > 0)
             {
                 //shoot
-                this->reloadBullet();
+                this->takeBullets();
                 this->createProjectile();
+            }
+            //if there are no bullets, but magazines
+            else if ( this->munition_->magazines() > 0 && this->munition_->bullets() == 0 )
+            {
+//COUT(0) << "LaserGun::fire - no bullets" << std::endl;
+                this->takeMagazines();
             }
             else
             {
-                if ( this->munition_->bullets() > 0)
-                {
-                    //shoot and reload
-                    this->takeBullets();
-                    this->reloadBullet();
-                    this->createProjectile();
-                }
-                //if there are no bullets, but magazines
-                else if ( this->munition_->magazines() > 0 && this->munition_->bullets() == 0 )
-                {
-                    //reload magazine
-                    this->takeMagazines();
-                    this->reloadMagazine();
-                }
-                else
-                {
-                    //no magazines
-                }
+//COUT(0) << "LaserGun::fire - no magazines" << std::endl;
+                //actions
             }
         }
         else
         {
-            //weapon not reloaded
+//COUT(0) << "LaserGun::fire - weapon not reloaded - bullets remaining:" << this->munition_->bullets() << std::endl;
+            //actions
         }
 
@@ -126,7 +109,7 @@
 
 
-    //weapon reloading
     void Weapon::bulletTimer(float bulletLoadingTime)
     {
+//COUT(0) << "Weapon::bulletTimer started" << std::endl;
         this->bReloading_ = true;
         this->bulletReloadTimer_.setTimer( bulletLoadingTime , false , this , createExecutor(createFunctor(&Weapon::bulletReloaded)));
@@ -134,4 +117,5 @@
     void Weapon::magazineTimer(float magazineLoadingTime)
     {
+//COUT(0) << "Weapon::magazineTimer started" << std::endl;
         this->bReloading_ = true;
         this->magazineReloadTimer_.setTimer( magazineLoadingTime , false , this , createExecutor(createFunctor(&Weapon::magazineReloaded)));
@@ -148,28 +132,26 @@
         this->bReloading_ = false;
         this->munition_->fillBullets();
+        this->magazineReadyToShoot_ = true;
+        this->bulletReadyToShoot_ = true;
     }
-
 
 
     void Weapon::attachNeededMunition(std::string munitionName)
     {
-        /*  if munition type already exists attach it, else create a new one of this type and attach it to the weapon and to the WeaponSystem
-        */
+//COUT(0) << "Weapon::attachNeededMunition, parentWeaponSystem=" << this->parentWeaponSystem_ << std::endl;
+        //if munition type already exists attach it, else create a new one of this type and attach it to the weapon and to the WeaponSystem
         if (this->parentWeaponSystem_)
         {
-            //getMunitionType returns 0 if there is no such munitionType
+//COUT(0) << "Weapon::attachNeededMunition " << munitionName << std::endl;
             Munition* munition = this->parentWeaponSystem_->getMunitionType(munitionName);
             if ( munition )
-            {
                 this->munition_ = munition;
-                this->setMunition();
-            }
             else
             {
-                //create new munition with identifier because there is no such munitionType
+                //create new munition with identifier
+//COUT(0) << "Weapon::attachNeededMunition, create new Munition of Type " << munitionName << std::endl;
                 this->munitionIdentifier_ = ClassByString(munitionName);
                 this->munition_ = this->munitionIdentifier_.fabricate(this);
                 this->parentWeaponSystem_->setNewMunition(munitionName, this->munition_);
-                this->setMunition();
             }
         }
@@ -177,20 +159,8 @@
 
 
-    Munition * Weapon::getAttachedMunition(std::string munitionType)
-    {
-        this->munition_ = this->parentWeaponSystem_->getMunitionType(munitionType);
-        return this->munition_;
-    }
+     /*get and set functions
+     *
+     */
 
-
-    //these function are defined in the weapon classes
-    void Weapon::takeBullets() { };
-    void Weapon::createProjectile() { };
-    void Weapon::takeMagazines() { };
-    void Weapon::reloadBullet() { };
-    void Weapon::reloadMagazine() { };
-
-
-    //get and set functions for XMLPort
     void Weapon::setMunitionType(std::string munitionType)
     {   this->munitionType_ = munitionType; }
@@ -211,21 +181,16 @@
     {   return this->magazineLoadingTime_;  }
 
-    void Weapon::setBulletAmount(unsigned int amount)
-    {   this->bulletAmount_ = amount; }
 
-    const unsigned int Weapon::getBulletAmount()
-    {   return this->bulletAmount_;  }
+    Munition * Weapon::getAttachedMunition(std::string munitionType)
+    {
+//COUT(0) << "Weapon::getAttachedMunition, parentWeaponSystem_="<< this->parentWeaponSystem_ << std::endl;
+        this->munition_ = this->parentWeaponSystem_->getMunitionType(munitionType);
+//COUT(0) << "Weapon::getAttachedMunition, munition_="<< this->munition_ << std::endl;
+        return this->munition_;
+    }
 
-    void Weapon::setMagazineAmount(unsigned int amount)
-    {   this->magazineAmount_ = amount; }
-
-    const unsigned int Weapon::getMagazineAmount()
-    {   return this->magazineAmount_;   }
-
-    void Weapon::setUnlimitedMunition(bool unlimitedMunition)
-    {   this->unlimitedMunition_ = unlimitedMunition;   }
-
-    const bool Weapon::getUnlimitedMunition()
-    {   return this->unlimitedMunition_;    }
+    void Weapon::takeBullets() { };
+    void Weapon::createProjectile() { };
+    void Weapon::takeMagazines() { };
 
 }
Index: code/branches/questsystem5/src/orxonox/objects/weaponSystem/Weapon.h
===================================================================
--- code/branches/questsystem5/src/orxonox/objects/weaponSystem/Weapon.h	(revision 2907)
+++ code/branches/questsystem5/src/orxonox/objects/weaponSystem/Weapon.h	(revision 2908)
@@ -62,5 +62,4 @@
             void magazineReloaded();
 
-            //XMLPort functions
             virtual void setMunitionType(std::string munitionType);
             virtual const std::string getMunitionType();
@@ -69,22 +68,9 @@
             virtual void setMagazineLoadingTime(float loadingTime);
             virtual const float getMagazineLoadingTime();
-            virtual void setBulletAmount(unsigned int amount);
-            virtual const unsigned int getBulletAmount();
-            virtual void setMagazineAmount(unsigned int amount);
-            virtual const unsigned int getMagazineAmount();
-            virtual void setUnlimitedMunition(bool unlimitedMunition);
-            virtual const bool getUnlimitedMunition();
 
-            //weapon actions
             virtual void takeBullets();
             virtual void takeMagazines();
             virtual void createProjectile();
-            virtual void reloadBullet();
-            virtual void reloadMagazine();
 
-            //manually set or reset
-            virtual void setWeapon();
-            virtual void setMunition();
-            
             inline void setParentWeaponSystem(WeaponSystem *parentWeaponSystem)
                 { this->parentWeaponSystem_=parentWeaponSystem; };
@@ -97,4 +83,5 @@
                 { return this->attachedToWeaponSlot_; }
 
+            virtual void setWeapon();
 
         private:
@@ -104,9 +91,6 @@
             bool bulletReadyToShoot_;
             bool magazineReadyToShoot_;
-            bool unlimitedMunition_;
             float bulletLoadingTime_;
             float magazineLoadingTime_;
-            unsigned int bulletAmount_;
-            unsigned int magazineAmount_;
             std::string munitionType_;
 
